const fs = require('fs');
const os = require('os');
const path = require('path');

// for some reason, runkit isn't detecting this dependency
// correctly so I'm manually requiring it here.
require('ignore');
require('wcwidth');

const git = require("isomorphic-git");

// Make temporary directory
const dir = fs.mkdtempSync(path.join(os.tmpdir(), 'test-'));
console.log(dir);
// Behold - it is empty!
fs.readdirSync(dir);;

await git.clone({
    fs,
    dir,
    url: 'https://github.com/isomorphic-git/isomorphic-git',
    ref: 'master',
    singleBranch: true,
    depth: 10
});

// Now it should not be empty...
fs.readdirSync(dir);;

await git.log({fs, dir});

await git.status({fs, dir, filepath: 'README.md'});

fs.writeFileSync(path.join(dir, 'README.md'), 'Very short README', 'utf8')
await git.status({fs, dir, filepath: 'README.md'});

await git.add({fs, dir, filepath: 'README.md'})
await git.status({fs, dir, filepath: 'README.md'});

fs.writeFileSync(path.join(dir, 'newfile.txt'), 'Hello World', 'utf8')
await git.status({fs, dir, filepath: 'newfile.txt'});

await git.add({fs, dir, filepath: 'newfile.txt'})
await git.status({fs, dir, filepath: 'newfile.txt'});

fs.unlinkSync(path.join(dir, 'package.json'))
await git.status({fs, dir, filepath: 'package.json'});

await git.remove({fs, dir, filepath: 'package.json'})
await git.status({fs, dir, filepath: 'package.json'});

await git.remove({fs, dir, filepath: 'package-lock.json'})
await git.status({fs, dir, filepath: 'package-lock.json'});

await git.add({fs, dir, filepath: 'package-lock.json'})
await git.status({fs, dir, filepath: 'package-lock.json'});

await git.commit({
  fs,
  dir,
  message: 'Delete package.json and overwrite README.',
  author: {
    name: 'Mr. Test',
    email: 'mrtest@example.com'
  }
});

commits = await git.log({fs, dir, depth: 1})
commits[0];